<script setup>
import { initModals } from "flowbite";
import { QrcodeStream } from "vue-qrcode-reader";
import { BarcodeDetector } from "@sec-ant/barcode-detector/pure";

globalThis.BarcodeDetector = BarcodeDetector;

onMounted(() => {
  initModals();
});

const result = ref("");
const error = ref("");

const onDetect = (detectedCodes) => {
  const [firstCode] = detectedCodes;
  result.value = firstCode.rawValue;

  console.log(result.value);
};

const onError = (err) => {
  error.value = `[${err.name}]: `;

  if (err.name === "NotAllowedError") {
    error.value += "you need to grant camera access permission";
  } else if (err.name === "NotFoundError") {
    error.value += "no camera on this device";
  } else if (err.name === "NotSupportedError") {
    error.value += "secure context required (HTTPS, localhost)";
  } else if (err.name === "NotReadableError") {
    error.value += "is the camera already in use?";
  } else if (err.name === "OverconstrainedError") {
    error.value += "installed cameras are not suitable";
  } else if (err.name === "StreamApiNotSupportedError") {
    error.value += "Stream API is not supported in this browser";
  } else if (err.name === "InsecureContextError") {
    error.value +=
      "Camera access is only permitted in secure context. Use HTTPS or localhost rather than HTTP.";
  } else {
    error.value += err.message;
  }
};

const paintBoundingBox = (detectedCodes, ctx) => {
  for (const detectedCode of detectedCodes) {
    const {
      boundingBox: { x, y, width, height },
    } = detectedCode;

    ctx.lineWidth = 2;
    ctx.strokeStyle = "#007bff";
    ctx.strokeRect(x, y, width, height);
  }
};

const schadules = [
  {
    subject: "Manajemen Bisnis Syariah",
    lecturer: "Tuba jazil, M.Sc",
    startTime: "07:00",
    endTIme: "09:30",
    room: "1.4",
  },
  {
    subject: "Akuntansi Syariah",
    lecturer: "Assoc. Prof. Dr. Murniati Mukhlisin, M.Acc., CFP.",
    startTime: "09:30",
    endTIme: "12:00",
    room: "1.4",
  },
];
</script>
<template>
  <div>
    <div class="my-5">
      <p class="font-semibold text-base text-dark-950">Jadwal Kuliah</p>
      <p class="text-dark-900 text-base">Senin, 24 Juli 2023</p>
    </div>
    <!-- list jadwal -->
    <div class="grid grid-cols-1 sm:grid-cols-2 md:grid-cols-1 gap-4">
      <div
        class="p-4 rounded-xl shadow-lg bg-light-50 flex flex-col md:flex-row gap-y-4 md:gap-x-4"
        v-for="schadule in schadules"
      >
        <div class="basis-7/12 flex flex-col md:flex-row gap-y-4 md:gap-x-4">
          <svg
            xmlns="http://www.w3.org/2000/svg"
            fill="none"
            viewBox="0 0 24 24"
            stroke-width="1.5"
            stroke="currentColor"
            class="w-10 h-10 stroke-accent-500 flex-shrink-0 flex-grow-0"
          >
            <path
              stroke-linecap="round"
              stroke-linejoin="round"
              d="M12 6.042A8.967 8.967 0 006 3.75c-1.052 0-2.062.18-3 .512v14.25A8.987 8.987 0 016 18c2.305 0 4.408.867 6 2.292m0-14.25a8.966 8.966 0 016-2.292c1.052 0 2.062.18 3 .512v14.25A8.987 8.987 0 0018 18a8.967 8.967 0 00-6 2.292m0-14.25v14.25"
            />
          </svg>
          <div class="flex-grow">
            <p>{{ schadule.subject }}</p>
            <p>{{ schadule.lecturer }}</p>
          </div>
        </div>
        <div class="basis-3/12">
          <p>{{ schadule.startTime + "-" + schadule.endTIme }}</p>
          <p>Room {{ schadule.room }}</p>
        </div>
        <div class="basis-2/12">
          <button
            data-modal-target="scannerModal"
            data-modal-toggle="scannerModal"
            class="w-full text-light-50 bg-primary-700 hover:bg-primary-900 focus:ring-4 focus:outline-none focus:ring-primary-700/50 font-Inter font-medium rounded-lg text-sm px-5 py-2.5 text-center inline-flex items-center justify-center mr-3 md:mr-0"
          >
            <svg
              xmlns="http://www.w3.org/2000/svg"
              fill="none"
              viewBox="0 0 24 24"
              stroke-width="1.5"
              stroke="currentColor"
              class="w-6 h-6 mr-3"
            >
              <path
                stroke-linecap="round"
                stroke-linejoin="round"
                d="M3.75 4.875c0-.621.504-1.125 1.125-1.125h4.5c.621 0 1.125.504 1.125 1.125v4.5c0 .621-.504 1.125-1.125 1.125h-4.5A1.125 1.125 0 013.75 9.375v-4.5zM3.75 14.625c0-.621.504-1.125 1.125-1.125h4.5c.621 0 1.125.504 1.125 1.125v4.5c0 .621-.504 1.125-1.125 1.125h-4.5a1.125 1.125 0 01-1.125-1.125v-4.5zM13.5 4.875c0-.621.504-1.125 1.125-1.125h4.5c.621 0 1.125.504 1.125 1.125v4.5c0 .621-.504 1.125-1.125 1.125h-4.5A1.125 1.125 0 0113.5 9.375v-4.5z"
              />
              <path
                stroke-linecap="round"
                stroke-linejoin="round"
                d="M6.75 6.75h.75v.75h-.75v-.75zM6.75 16.5h.75v.75h-.75v-.75zM16.5 6.75h.75v.75h-.75v-.75zM13.5 13.5h.75v.75h-.75v-.75zM13.5 19.5h.75v.75h-.75v-.75zM19.5 13.5h.75v.75h-.75v-.75zM19.5 19.5h.75v.75h-.75v-.75zM16.5 16.5h.75v.75h-.75v-.75z"
              />
            </svg>
            Absen
          </button>
        </div>
      </div>
    </div>
    <div
      id="scannerModal"
      tabindex="-1"
      aria-hidden="true"
      class="fixed top-0 left-0 right-0 z-50 hidden w-full p-4 overflow-x-hidden overflow-y-auto md:inset-0 h-[calc(100%-1rem)] max-h-full"
    >
      <div class="relative w-full max-w-sm max-h-full">
        <!-- Modal content -->
        <div class="relative bg-light-50 rounded-xl shadow">
          <div class="p-4 text-center">
            <p class="mb-4 font-semibold text-dark-950">Scan Qr-Code</p>
            <qrcode-stream
              class="rounded-lg relative bg-dark-950"
              :track="paintBoundingBox"
              @detect="onDetect"
              @error="onError"
            />
            <!-- alert success -->
            <div
              v-if="result"
              class="flex items-center p-4 mt-4 text-sm text-left text-success-700 border border-success-300 rounded-lg bg-success-50"
              role="alert"
            >
              <svg
                class="flex-shrink-0 inline w-4 h-4 mr-3"
                aria-hidden="true"
                xmlns="http://www.w3.org/2000/svg"
                fill="currentColor"
                viewBox="0 0 20 20"
              >
                <path
                  d="M10 .5a9.5 9.5 0 1 0 9.5 9.5A9.51 9.51 0 0 0 10 .5ZM9.5 4a1.5 1.5 0 1 1 0 3 1.5 1.5 0 0 1 0-3ZM12 15H8a1 1 0 0 1 0-2h1v-3H8a1 1 0 0 1 0-2h2a1 1 0 0 1 1 1v4h1a1 1 0 0 1 0 2Z"
                />
              </svg>
              <span class="sr-only">Info</span>
              <div>
                {{ result }}
              </div>
            </div>
            <!-- alert error -->
            <div
              v-if="error"
              class="flex items-center p-4 mt-4 text-sm text-left text-danger-700 border border-danger-300 rounded-lg bg-danger-50"
              role="alert"
            >
              <svg
                class="flex-shrink-0 inline w-4 h-4 mr-3"
                aria-hidden="true"
                xmlns="http://www.w3.org/2000/svg"
                fill="currentColor"
                viewBox="0 0 20 20"
              >
                <path
                  d="M10 .5a9.5 9.5 0 1 0 9.5 9.5A9.51 9.51 0 0 0 10 .5ZM9.5 4a1.5 1.5 0 1 1 0 3 1.5 1.5 0 0 1 0-3ZM12 15H8a1 1 0 0 1 0-2h1v-3H8a1 1 0 0 1 0-2h2a1 1 0 0 1 1 1v4h1a1 1 0 0 1 0 2Z"
                />
              </svg>
              <span class="sr-only">Info</span>
              <div>
                {{ error }}
              </div>
            </div>
            <!-- close btn -->
            <button
              data-modal-hide="scannerModal"
              type="button"
              class="w-full text-light-50 bg-primary-700 hover:bg-primary-900 focus:ring-4 focus:outline-none focus:ring-primary-700/50 font-Inter font-medium rounded-lg text-sm px-5 py-2.5 text-center mt-4"
            >
              Close Qr-Scanner
            </button>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<style>
.qrcode-stream-overlay {
  width: 100%;
  height: 100%;
  position: absolute;
  top: 0;
  left: 0;
}

.qrcode-stream-camera {
  border-radius: 8px;
}
</style>
